<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>sdioemb: Userspace SDIO library (libsdio)</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="pages.html">Related&nbsp;Pages</a></div>
<h1>Userspace SDIO library (libsdio)</h1><em>libsdio</em> is a Linux C library for accessing SDIO cards.  
<a href="#_details">More...</a><table border=0 cellpadding=0 cellspacing=0>
<tr><td></td></tr>
<tr><td colspan=2><br><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>typedef sdio_uif *&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>typedef void(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga1">sdio_int_handler_t</a> )(<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, void *arg)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>typedef void(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a> )(<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, void *arg, int status)</td></tr>

<tr><td colspan=2><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga3">sdio_open</a> (const char *dev_filename, <a class="el" href="group__libsdio.html#ga1">sdio_int_handler_t</a> int_handler, void *arg)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga4">sdio_interrupt_mask</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga5">sdio_interrupt_unmask</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga6">sdio_close</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga7">sdio_num_functions</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga8">sdio_set_bus_width</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int bus_width)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga9">sdio_set_max_bus_freq</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int max_freq)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>uint16_t&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga10">sdio_manf_id</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>uint16_t&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga11">sdio_card_id</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>uint8_t&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga12">sdio_std_if</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga13">sdio_max_block_size</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga14">sdio_block_size</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga15">sdio_set_block_size</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, int blksz)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga16">sdio_read8</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, uint32_t addr, uint8_t *data)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga17">sdio_write8</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, uint32_t addr, uint8_t data)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga18">sdio_read</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, uint32_t addr, uint8_t *data, size_t len, int block_size)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga19">sdio_write</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, uint32_t addr, const uint8_t *data, size_t len, int block_size)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga20">sdio_read8_async</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, uint32_t addr, uint8_t *data, <a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a> callback, void *arg)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga21">sdio_write8_async</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, uint32_t addr, uint8_t data, <a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a> callback, void *arg)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga22">sdio_read_async</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, uint32_t addr, uint8_t *data, size_t len, int block_size, <a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a> callback, void *arg)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga23">sdio_write_async</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, int func, uint32_t addr, const uint8_t *data, size_t len, int block_size, <a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a> callback, void *arg)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="group__libsdio.html#ga24">sdio_reinsert_card</a> (<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif)</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
<em>libsdio</em> is a Linux C library for accessing SDIO cards. 
<p>
Use of this library requires several <em>sdioemb</em> kernel modules to be loaded:<ul>
<li><code>sdio</code>.</li><li><code>An</code> SDIO slot driver (e.g., <code>slot_shc</code> for a standard PCI SDIO Host Controller).</li><li><code>sdio_uif</code> which provides the required character devices (/dev/sdio_uif0 for the card in SDIO slot 0 etc.). </li></ul>
<hr><h2>Typedef Documentation</h2>
<a class="anchor" name="ga1" doxytag="libsdio.h::sdio_int_handler_t" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> typedef void(* <a class="el" href="group__libsdio.html#ga1">sdio_int_handler_t</a>)(<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, void *arg)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Card interrupt handler function.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>handle to the interrupting device. </td></tr>
    <tr><td valign=top><em>arg</em>&nbsp;</td><td>data supplied by the caller of sdio_open(). </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga2" doxytag="libsdio.h::sdio_io_callback_t" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> typedef void(* <a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a>)(<a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> uif, void *arg, int status)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Asynchronous IO completion callback function.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>handle to the device that completed the IO operation. </td></tr>
    <tr><td valign=top><em>arg</em>&nbsp;</td><td>data supplied by the caller of the asynchronous IO operation. </td></tr>
    <tr><td valign=top><em>status</em>&nbsp;</td><td>status of the IO operation. 0 is success; -EIO, -EINVAL, -ETIMEDOUT etc. on an error. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga0" doxytag="libsdio.h::sdio_uif_t" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> typedef struct sdio_uif* <a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Handle to an opened SDIO Userspace Interface device.     </td>
  </tr>
</table>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="ga14" doxytag="libsdio.h::sdio_block_size" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_block_size </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Return a function's current block size.<p>
<dl compact><dt><b>Note:</b></dt><dd>This returns the driver's view of the block size and not the value in the function's block size register.</dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function to query.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>the current block size. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga11" doxytag="libsdio.h::sdio_card_id" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> uint16_t sdio_card_id </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>uif</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Return the card's card (device) ID.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>card ID. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga6" doxytag="libsdio.h::sdio_close" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_close </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>uif</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Close an opened SDIO Userspace Interface device, freeing all associated resources.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>handle to the device. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga4" doxytag="libsdio.h::sdio_interrupt_mask" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_interrupt_mask </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>uif</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Mask the SDIO interrupt.<p>
Call this in an interrupt handler to allow the processing of interrupts to be deferred until after the interrupt handler has returned.<p>
<dl compact><dt><b>Note:</b></dt><dd><em>Must</em> only be called from within the interrupt handler registered with sdio_open().</dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga5" doxytag="libsdio.h::sdio_interrupt_unmask" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_interrupt_unmask </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>uif</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Unmask the SDIO interrupt.<p>
Unmasks the SDIO interrupt if it had previously been masked with <a class="el" href="group__libsdio.html#ga4">sdio_interrupt_mask()</a>.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga10" doxytag="libsdio.h::sdio_manf_id" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> uint16_t sdio_manf_id </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>uif</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Return the card's manufacturer (vendor) ID.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>manufacturer ID. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga13" doxytag="libsdio.h::sdio_max_block_size" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_max_block_size </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Return a function's maximum supported block size.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function to query.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>maximum block size. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga7" doxytag="libsdio.h::sdio_num_functions" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_num_functions </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>uif</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Return the number of functions the card has.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>number of card functions. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga3" doxytag="libsdio.h::sdio_open" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> <a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a> sdio_open </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">const char *&nbsp;</td>
          <td class="mdname" nowrap> <em>dev_filename</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap><a class="el" href="group__libsdio.html#ga1">sdio_int_handler_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>int_handler</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void *&nbsp;</td>
          <td class="mdname" nowrap> <em>arg</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Open a SDIO Userspace Interface device and (optionally) register a card interrupt handler and enable card interrupts.<p>
Card interrupts are masked before calling int_handler and are unmasked when int_handler returns (unless <a class="el" href="group__libsdio.html#ga4">sdio_interrupt_mask()</a> is called).<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>dev_filename</em>&nbsp;</td><td>filename of the device to open. </td></tr>
    <tr><td valign=top><em>int_handler</em>&nbsp;</td><td>card interrupt handler; or NULL if no interrupt handler is required. </td></tr>
    <tr><td valign=top><em>arg</em>&nbsp;</td><td>argument to be passed to the interrupt handler.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>handle to the opened device; or NULL on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga18" doxytag="libsdio.h::sdio_read" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_read </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>size_t&nbsp;</td>
          <td class="mdname" nowrap> <em>len</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>block_size</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read a buffer from a 8 bit wide register/FIFO.<p>
The buffer read uses a fixed (not incrementing) address.<p>
<em>block_size</em> <em>must</em> be set to the value writted into <em>func's</em> I/O block size FBR register.<p>
If <em>len</em>  <em>block_size</em> == 0, a block mode transfer is used; a byte mode transfer is used if <em>len</em> &lt; <em>block_size</em>.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register/FIFO address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>buffer to store the data read. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of data to read. </td></tr>
    <tr><td valign=top><em>block_size</em>&nbsp;</td><td>block size to use for this transfer.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga16" doxytag="libsdio.h::sdio_read8" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_read8 </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read an 8 bit register.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>the data read.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga20" doxytag="libsdio.h::sdio_read8_async" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_read8_async </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap><a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>callback</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void *&nbsp;</td>
          <td class="mdname" nowrap> <em>arg</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read an 8 bit register, without waiting for completion.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>the data read. </td></tr>
    <tr><td valign=top><em>callback</em>&nbsp;</td><td>function to be called when the read completes. </td></tr>
    <tr><td valign=top><em>arg</em>&nbsp;</td><td>argument to be passed to callback.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga22" doxytag="libsdio.h::sdio_read_async" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_read_async </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>size_t&nbsp;</td>
          <td class="mdname" nowrap> <em>len</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>block_size</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap><a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>callback</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void *&nbsp;</td>
          <td class="mdname" nowrap> <em>arg</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Read a buffer from a 8 bit wide register/FIFO, without waiting for completion.<p>
The buffer read uses a fixed (not incrementing) address.<p>
<em>block_size</em> <em>must</em> be set to the value writted into <em>func's</em> I/O block size FBR register.<p>
If <em>len</em>  <em>block_size</em> == 0, a block mode transfer is used; a byte mode transfer is used if <em>len</em> &lt; <em>block_size</em>.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register/FIFO address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>buffer to store the data read. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of data to read. </td></tr>
    <tr><td valign=top><em>block_size</em>&nbsp;</td><td>block size to use for this transfer. </td></tr>
    <tr><td valign=top><em>callback</em>&nbsp;</td><td>function to be called when the read completes. </td></tr>
    <tr><td valign=top><em>arg</em>&nbsp;</td><td>argument to be passed to callback.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga24" doxytag="libsdio.h::sdio_reinsert_card" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_reinsert_card </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>uif</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Force a card removal and reinsertion.<p>
This will power cycle the card if the slot hardware supports power control.<p>
<dl compact><dt><b>Note:</b></dt><dd>The device handle will no longer be valid.</dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga15" doxytag="libsdio.h::sdio_set_block_size" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_set_block_size </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>blksz</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Set a function's block size.<p>
The function's block size registers will be written if necessary.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>function to modify. </td></tr>
    <tr><td valign=top><em>blksz</em>&nbsp;</td><td>the new block size; or 0 for the default size.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga8" doxytag="libsdio.h::sdio_set_bus_width" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_set_bus_width </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>bus_width</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Set an SDIO bus to 1 bit or 4 bit wide mode.<p>
The CCCR bus interface control register will be read and rewritten with the new bus width.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>bus_width</em>&nbsp;</td><td>bus width (1 or 4).</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on error with errno set.</dd></dl>
<dl compact><dt><b>Note:</b></dt><dd>The card capabilities are <em>not</em> checked. The user should ensure 4 bit mode is not enabled on a card that does not support it. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga9" doxytag="libsdio.h::sdio_set_max_bus_freq" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void sdio_set_max_bus_freq </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>max_freq</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Limit the frequency of (or stop) the SD bus clock.<p>
The frequency cannot be set greater than that supported by the card or the controller.<p>
<dl compact><dt><b>Note:</b></dt><dd>Stopping the bus clock while other device drivers are executing commands may result in those commands not completing until the bus clock is restarted.</dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>max_freq</em>&nbsp;</td><td>maximum frequency (Hz) or 0 to stop the bus clock until the start of the next command. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga12" doxytag="libsdio.h::sdio_std_if" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> uint8_t sdio_std_if </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Return the standard interface code for a function.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function to query.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>the standard interface. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga19" doxytag="libsdio.h::sdio_write" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_write </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>const uint8_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>size_t&nbsp;</td>
          <td class="mdname" nowrap> <em>len</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>block_size</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Write a buffer to an 8 bit wide register/FIFO.<p>
The buffer write uses a fixed (not incrementing) address.<p>
<em>block_size</em> <em>must</em> be set to the value writted into <em>func's</em> I/O block size FBR register.<p>
If <em>len</em>  <em>block_size</em> == 0, a block mode transfer is used; a byte mode transfer is used if <em>len</em> &lt; <em>block_size</em>.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register/FIFO address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>buffer of data to write. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of the data to write. </td></tr>
    <tr><td valign=top><em>block_size</em>&nbsp;</td><td>block size to use for this transfer.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga17" doxytag="libsdio.h::sdio_write8" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_write8 </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Write an 8 bit register.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>the data to write.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga21" doxytag="libsdio.h::sdio_write8_async" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_write8_async </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint8_t&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap><a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>callback</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void *&nbsp;</td>
          <td class="mdname" nowrap> <em>arg</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Write an 8 bit register, without waiting for completion.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>the data to write. </td></tr>
    <tr><td valign=top><em>callback</em>&nbsp;</td><td>function to be called when the write completes. </td></tr>
    <tr><td valign=top><em>arg</em>&nbsp;</td><td>argument to be passed to callback.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="ga23" doxytag="libsdio.h::sdio_write_async" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int sdio_write_async </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__libsdio.html#ga0">sdio_uif_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>uif</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>func</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>uint32_t&nbsp;</td>
          <td class="mdname" nowrap> <em>addr</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>const uint8_t *&nbsp;</td>
          <td class="mdname" nowrap> <em>data</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>size_t&nbsp;</td>
          <td class="mdname" nowrap> <em>len</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>block_size</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap><a class="el" href="group__libsdio.html#ga2">sdio_io_callback_t</a>&nbsp;</td>
          <td class="mdname" nowrap> <em>callback</em>, </td>
        </tr>
        <tr>
          <td></td>
          <td></td>
          <td class="md" nowrap>void *&nbsp;</td>
          <td class="mdname" nowrap> <em>arg</em></td>
        </tr>
        <tr>
          <td></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>

      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Write a buffer to an 8 bit wide register/FIFO, without waiting for completion.<p>
The buffer write uses a fixed (not incrementing) address.<p>
<em>block_size</em> <em>must</em> be set to the value writted into <em>func's</em> I/O block size FBR register.<p>
If <em>len</em>  <em>block_size</em> == 0, a block mode transfer is used; a byte mode transfer is used if <em>len</em> &lt; <em>block_size</em>.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>uif</em>&nbsp;</td><td>device handle. </td></tr>
    <tr><td valign=top><em>func</em>&nbsp;</td><td>card function. </td></tr>
    <tr><td valign=top><em>addr</em>&nbsp;</td><td>register/FIFO address. </td></tr>
    <tr><td valign=top><em>data</em>&nbsp;</td><td>buffer of data to write. </td></tr>
    <tr><td valign=top><em>len</em>&nbsp;</td><td>length of the data to write. </td></tr>
    <tr><td valign=top><em>block_size</em>&nbsp;</td><td>block size to use for this transfer. </td></tr>
    <tr><td valign=top><em>callback</em>&nbsp;</td><td>function to be called when the write completes. </td></tr>
    <tr><td valign=top><em>arg</em>&nbsp;</td><td>argument to be passed to callback.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; or -ve on error with errno set. </dd></dl>
    </td>
  </tr>
</table>
<hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:54 2008 for sdioemb by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
